/*!
 * @file glgui_radar.h
 * @brief Definition of an Radar, that displays a bar and a Text
*/

#ifndef _GLGUI_RADAR_H
#define _GLGUI_RADAR_H

#include "glgui_widget.h"

class WorldEntity;

namespace OrxGui
{

  //! A class for ...
  class GLGuiRadar : public GLGuiWidget
  {

  public:
    GLGuiRadar();
    virtual ~GLGuiRadar();

    void setRange(float range);
    float range() const { return this->_range; }

  protected:
    virtual void resize();
    virtual void showing();
    virtual void hiding();

  private:
    typedef struct
    {

      Color                     dotColor;
      std::list<WorldEntity*>&  entityList;
      std::vector<Vector2D>     position;
    } DotList;

    std::vector<DotList>        _dotLists;

    float                       _range;

  };
}
#endif /* _GLGUI_RADAR_H */
